REM Program: Shuttle v1.0a PD 2002.

DEFSNG A-Z ' declare all variables
REM $DYNAMIC ' declare arrays at runtime

' define functions
DECLARE FUNCTION rho# (ntheta#, a!, b!)

' declare global variables
COMMON SHARED ndta AS INTEGER
COMMON SHARED sumtheta
COMMON SHARED deltheta AS INTEGER

' declare all arrays
DIM SHARED phi(6) AS DOUBLE
DIM SHARED phi4(6) AS DOUBLE

' set screen mode 640x480
SCREEN 12, 0

' get input values
LOCATE 1, 1, 1
PRINT "Enter (S)tereo/(M)ono display:";
DO
   x$ = ""
   DO
      x$ = INKEY$
      IF LEN(x$) THEN
         EXIT DO
      END IF
   LOOP
   SELECT CASE x$
   CASE "S", "s"
      mono = 0
      PRINT "s"
      EXIT DO
   CASE "M", "m"
      mono = -1
      PRINT "m"
      EXIT DO
   END SELECT
LOOP

' data points per pi control circle arclength
DO
   PRINT "Enter data points(30,60,90,180,360)";
   INPUT dpts
   SELECT CASE dpts
   CASE 30, 60, 90, 180, 360
      EXIT DO
   END SELECT
LOOP

' scaling factor
DO
   PRINT "Enter scaling factor(.125,.25,.5,1):";
   INPUT scale
   SELECT CASE scale
   CASE .125, .25, .5, 1
      EXIT DO
   END SELECT
LOOP

' deltz  [trial data points]
DO
   PRINT "Enter zref screen factor(-32,-16,-8,-4,-2,0,2,4,8):";
   INPUT zref
   SELECT CASE zref
   CASE -32, -16, -8, -4, -2, 0, 2, 4, 8
      EXIT DO
   END SELECT
LOOP

' circle step
DO
   PRINT "Enter circle step = pi divide by:(3,9,12,15,18)";
   INPUT circle.coef
   SELECT CASE circle.coef
   CASE 3, 9, 12, 15, 18
      EXIT DO
   END SELECT
LOOP

' delclare some variables
pi = ATN(1) * 4     ' define PI
instar = 24
pixratio = 48 / 64 ' screen pixels ratio
scrnset = 4 / 3    ' screen size ratio
pix = 64 * scale   ' pixels per inch, modify by scale factor
clrC = 13: clrE = 5: clRF = 1  ' color curve, ellipse, ref lines
deltheta = (dpts / 180) * 10 ' for surface fuselage lines at degree intervals
' plx = parallax (eye separation) / 2
plx = 1.2
' hypC is coeff. C in z = C*cosh(Se)
hypC = 1
setx = 330: sety = 240    ' v-basic screen set zero on 640 * 200 pixels
epi = pi / dpts    ' epsilon for eliminating discontinuity at pi/2, -pi/2
                   ' skips data point: note for error report
a1 = 1.7: b1 = 1.5     ' upper test ellipse:  b must be less than a
a2 = 1.6: b2 = 1.5     ' lower test ellipse:   also  [ b < a ]
thestar = pi / 3   ' stack, test data points
'phistar = pi / 12 ' roll, yaw, pitch
omstar = pi / 2    ' [trials]

 xref = 0  '  deltx     three axis reference translation
 yref = 0  '  delty     vector on [x' y' z']
'zref = 8  '  deltz     [trial data points]

' start main program loop
DO
   FOR phistar = pi / 6 TO 13 * pi / 6 STEP pi / (circle.coef)
   CLS
   COLOR 15
   LOCATE 2, 30
   PRINT "Startech Industries Inc. Space Shuttle Hull v1.0a:";
   COLOR 15
   LOCATE 2, 2
   PRINT "Phi:";
   LOCATE 2, 9
   PRINT "Theta:";
   LOCATE 2, 18
   PRINT "Omega:";
   COLOR 14
   LOCATE 4, 4
   PRINT INT(10 * phistar * 180 / pi + .01) / 10;
   LOCATE 4, 11
   PRINT INT(10 * thestar * 180 / pi + .01) / 10;
   LOCATE 4, 19
   PRINT INT(10 * omstar * 180 / pi + .01) / 10;

   a = a1: b = b1   ' for integration 0 to pi/2 - epi  (top ellipse and
   clr = 1          ' color for reference lines       '   mirror image)
   Rx = a / 6: Ry = 0: Rz = 0
   zflag = 0
   xflag = -1
   xcr = -a / 6
   GOSUB refline      ' x-axis marker, y = 0 , z = 0
   xflag = 0

   Rx = 0: Ry = b / 6: Rz = 0
   xflag = 0
   yflag = -1
   ycr = -b / 6
   GOSUB refline      ' y-axis marker, x = 0 , z = 0
   yflag = 0

   Rx = a: Ry = 0: Rz = 4.3
   yflag = 0
   zflag = -1
   zcr = 6.3
   GOSUB refline       ' top center reference line part 2

   Rx = a: Ry = 0: Rz = -3
   yflag = 0
   zflag = -1
   zcr = -4.3
   GOSUB refline       ' top center reference line part 3

   zflag = 0

   ' integrate ellipse zero to pi/2 - epi
   ndta = 0
   last2 = 0: last4 = 0
   thestart = 0
   cntrl = 1
   se = 0
   selocal = 0
   selast = 0
   sumtheta = 0

   FOR theta = epi TO pi / 2 - epi STEP pi / dpts  'increment theta
      ' surface line flag
      IF ndta = sumtheta THEN
         flagS = -1
      ELSE
         flagS = 0
      END IF
      ndta = ndta + 1
      GOSUB vectors
      Rx = x: Ry = y: Rz = z
      GOSUB curvplot
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      Rx = x: Ry = y: Rz = -z
      GOSUB curvplot
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      Rx = x: Ry = -y: Rz = z
      GOSUB curvplot
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      Rx = x: Ry = -y: Rz = -z
      GOSUB curvplot
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      IF flagS = -1 THEN
         sumtheta = sumtheta + deltheta
      END IF
   NEXT

   ' integrate from pi/2 to pi - epi
   a = a2: b = b2         ' bottom ellipse and mirror image
   selocal = 0
   se = 0              ' error note:   last interval of top half
   ndta = 0            ' ellipse gets left out here;  will correct with
   thestart = pi / 2   ' see weierstrass  1879
   cntrl = 2
   sumtheta = 0

   FOR theta = epi + pi / 2 TO -epi + pi STEP pi / dpts
      ' surface line flag
      IF ndta = sumtheta THEN
         flagS = -1
      ELSE
         flagS = 0
      END IF
      ndta = ndta + 1
      GOSUB vectors      ' generate hyperbolic cosine position vectors
      Rx = x: Ry = y: Rz = z
      GOSUB curvplot           ' plot hyperbolic cosine curve
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      Rx = x: Ry = y: Rz = -z
      GOSUB curvplot             ' plot mirror image: y = -y
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      Rx = x: Ry = -y: Rz = z
      GOSUB curvplot
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      Rx = x:   Ry = -y: Rz = -z
      GOSUB curvplot
      IF flagS = -1 THEN
         GOSUB surfaceline
      END IF
      ' surface line increments
      IF flagS = -1 THEN
         sumtheta = sumtheta + deltheta
      END IF
   NEXT
   zflag = -1
   Rx = -a2: Ry = 0: Rz = -6
   zcr = 6
   clr = 5
   GOSUB refline     ' bottom center reference line
   zflag = 0
   NEXT
LOOP
END

' integrates arclength of reference ellipse
arcellipse:   
phi0 = thestart  ' set interval begin
phi2 = 0         ' reset transition variables
phi4 = 0         ' note : parabolic approximation
arcse = 0        ' also note : interval pi/2 - epi to pi/2 will be
                 ' left out due to discontinuity at pi/2
FOR n = 0 TO 6
   phi(n) = phi0 + (pi / dpts) * n / 6
NEXT

FOR n = 1 TO 5
   phi2 = 2 * rho(phi(n), a, b)
NEXT

FOR n = 1 TO 6
   phi4 = phi4 + 4 * rho(((phi(n) + phi(n - 1)) / 2), a, b)
NEXT

front = (phi(6) - phi(0)) / 36
start = phi0 + phi(6)

arcse = front * (start + phi2 + phi4)
selocal = selocal + arcse

IF cntrl = 1 THEN  ' for bottom portion of hypC curve
   se = selocal    ' se in radians
   selast = se     ' ERROR REPORT:  arclength from pi/2-epi tp pi/2 will
ELSE               ' plotted off by this amount, unoticeable but not okay;
   se = selocal + selast ' have exact arclength solution almost ready -
END IF                   ' very difficult series - will check with weierstrass
RETURN

' rotation matrix, or tensor, in vector form, very beautiful tri-symmetry
rotate:   
xdelx = -Rx * SIN(thestar)
xdely = Rx * COS(thestar) * COS(omstar)
xdelz = Rx * COS(thestar) * SIN(omstar)

ydelx = Ry * SIN(phistar) * COS(thestar)
ydely = -Ry * (COS(phistar) * SIN(omstar) - SIN(phistar) * SIN(thestar) * COS(omstar))
ydelz = Ry * (COS(phistar) * COS(omstar) + SIN(phistar) * SIN(thestar) * SIN(omstar))

zdelx = Rz * COS(phistar) * COS(thestar)
zdely = Rz * (COS(phistar) * SIN(thestar) * COS(omstar) + SIN(phistar) * SIN(omstar)) ' * COS(thestar))
zdelz = Rz * (COS(phistar) * SIN(thestar) * SIN(omstar) - SIN(phistar) * COS(omstar))

deltx = xdelx + ydelx + zdelx      ' accumulate vector components from
delty = xdely + ydely + zdely       ' [ x y z ] vector to [ x' y' z' ]
deltz = xdelz + ydelz + zdelz         ' ( 3-d vector spaces, 4-d in motion )
RETURN

image:                       ' calculate screen images, input is [ x' y' z' ]
zstrI = (pix * instar - zprmI) '    and output is:
Iphi = ATN(xprmI / zstrI)      '         ImC   mono x screen position (xstar)
'xstrI = 12 * 80 * TAN(Iphi)   '         ImY   y screen position (ystar)
Iomega = ATN(yprmI / zstrI)    '       zstrI   depth from screen
                               '         ImL   left screen xstar
                               '         ImR   right screen xstar

ImC = instar * pix * TAN(Iphi)
ImR = instar * pix * (xprmI + plx * pix) / (instar * pix - zprmI) - plx * pix
ImL = instar * pix * (xprmI - plx * pix) / (instar * pix - zprmI) + plx * pix
ImY = -instar * pix * scrnset * pixratio * TAN(Iomega)
RETURN

' calculates hypC and ellipse vectors in [ x y z ]
vectors: 
bva = b ^ 2 / a ^ 2          ' b squared over a '
avb = 1 / bva                ' a squared over b squared
x11 = (1 - (1 - bva) * COS(theta) ^ 2)
x = SGN(COS(theta)) * a * SQR(1 - (SIN(theta) ^ 2) / x11)
y11 = (1 - (1 - avb) * SIN(theta) ^ 2)
y = SGN(SIN(theta)) * b * SQR(1 - (COS(theta) ^ 2) / y11)
rhosq = x ^ 2 + y ^ 2

GOSUB arcellipse ' calculates se

' z is hyperbolic cosine of ellipse arclength at theta
z = SQR(rhosq) * (EXP(se) + EXP(-se)) / 2
RETURN

'  receives Rx : Ry : Rz   and rotates to xprime, yprime, zprime
'  then translates  xref, yref, zref   and finally
'  transforms to xstarL, xstarR, and ystar.
curvplot:
IF Rz >= 6 THEN
   Rz = 6
END IF
IF Rz <= -6 THEN
   Rz = -6
END IF
GOSUB rotate

xprime = pix * (xref + deltx)
yprime = pix * (yref + delty)
zprime = pix * (zref + deltz)

IF prmflag = -1 THEN           ' for prime data output
   count1 = count1 + 1
   IF count1 = 3 THEN
      prmflag = 0
      count1 = 0
   END IF
ELSE
   xprm = INT(100 * xprime / pix) / 100 '  [ x' y' z' ]
   yprm = INT(100 * yprime / pix) / 100
   zprm = INT(100 * zprime / pix) / 100 ' needs to skip mirror image
                                        ' data so output doesn't oscillate
   COLOR 15
   LOCATE 29, 2
   PRINT "Position vector:";
   COLOR 14
   LOCATE 29, 21
   PRINT xprm;
   LOCATE 29, 28
   PRINT yprm;
   LOCATE 29, 35
   PRINT zprm;
   prmflag = -1
END IF

zstar = (instar * pix - zprime)
IF zstar > 0 THEN     ' zstar postitive for red-green mix
   Iphi = ATN(xprime / zstar)
   Iomega = ATN(yprime / zstar)
   xstar = instar * pix * TAN(Iphi)   ' note for behind eye angles > pi/2
   xstarR = instar * pix * (xprime + plx * pix) / (instar * pix - zprime) - plx * pix
   xstarL = instar * pix * (xprime - plx * pix) / (instar * pix - zprime) + plx * pix
   ystar = -instar * pix * scrnset * pixratio * TAN(Iomega)
   IF mono = -1 THEN
      PSET (xstar + setx, ystar + sety), clrC
   ELSE
      PSET (xstarL + setx, ystar + sety), 4 'clrC
      PSET (xstarR + setx, ystar + sety), 1 'clrC
   END IF
END IF

IF primflag2 = -1 THEN
   count = count + 1
   IF count = 3 THEN
      primflag2 = 0
      count = 0
   END IF
ELSE
   COLOR 15
   LOCATE 24, 2
   PRINT "Ellipse:";
   LOCATE 26, 23
   PRINT "(Virtual)";
   COLOR 14
   LOCATE 26, 2
   PRINT INT(100 * Rx) / 100;
   LOCATE 26, 9
   PRINT INT(100 * Ry) / 100;
   LOCATE 26, 16
   PRINT INT(100 * Rz) / 100; "  ";
   primflag2 = -1
END IF

Rzhold = Rz
Rz = 0

' plot reference ellipse
GOSUB rotate
Exprime = pix * (xref + deltx)
Eyprime = pix * (yref + delty)
Ezprime = pix * (zref + deltz)

IF primflag3 = -1 THEN
   count3 = count3 + 1
   IF count3 = 3 THEN
      primflag3 = 0
      count3 = 0
   END IF
ELSE
   COLOR 15
   LOCATE 27, 24
   PRINT "(Prime)";
   COLOR 14
   LOCATE 27, 3
   PRINT INT(100 * deltx) / 100;
   LOCATE 27, 10
   PRINT INT(100 * delty) / 100;
   LOCATE 27, 17
   PRINT INT(100 * deltz) / 100;
   primflag3 = -1
END IF

Ezstar = (instar * pix - Ezprime)  ' redundant (first composition) imaging
Iphi = ATN(Exprime / Ezstar)       ' solution, refined in subroutine image
Iomega = ATN(Eyprime / Ezstar)     ' - modulating program in progress -

Exstar = instar * pix * TAN(Iphi)
ExstarR = instar * pix * (Exprime + plx * pix) / (instar * pix - Ezprime) - plx * pix
ExstarL = instar * pix * (Exprime - plx * pix) / (instar * pix - Ezprime) + plx * pix
Eystar = -instar * pix * scrnset * pixratio * TAN(Iomega)

IF mono = -1 THEN
   PSET (Exstar + setx, Eystar + sety), clrE
ELSE
   PSET (ExstarL + setx, Eystar + sety), 4 'clrE
   PSET (ExstarR + setx, Eystar + sety), 1 'clrE
END IF
Rz = Rzhold

' check keyboard buffer
x$ = INKEY$
IF x$ = CHR$(27) THEN
   COLOR 7
   CLS
   END
END IF
IF x$ = " " THEN
   DO UNTIL INKEY$ <> ""
   LOOP
END IF
RETURN

' reference lines, controllability awkward here
refline: 
GOSUB rotate
xprmI = pix * (deltx + xref)
yprmI = pix * (delty + yref)
zprmI = pix * (deltz + zref)

GOSUB image
tcntr1 = ImC
tcntrL = ImL
tcntrR = ImR
tcntrY = ImY

IF zflag = -1 THEN
   Rz = zcr
END IF
IF xflag = -1 THEN
   Rx = xcr
END IF
IF yflag = -1 THEN
   Ry = ycr
END IF

GOSUB rotate
xprmI = pix * (deltx + xref)
yprmI = pix * (delty + yref)
zprmI = pix * (deltz + zref)

GOSUB image
tcntr2 = ImC
tcntrL2 = ImL
tcntrR2 = ImR
tcntrY2 = ImY

IF mono = -1 THEN
   LINE (tcntr1 + setx, tcntrY + sety)-(tcntr2 + setx, tcntrY2 + sety), clr
ELSE
   LINE (tcntrL + setx, tcntrY + sety)-(tcntrL2 + setx, tcntrY2 + sety), 4 'clr
   LINE (tcntrR + setx, tcntrY + sety)-(tcntrR2 + setx, tcntrY2 + sety), 1 'clr
END IF
RETURN

pointset:
IF mono = -1 THEN
   PSET (ImC + setx, ImY + sety), clrv
ELSE
   PSET (ImL + setx, ImY + sety), clrv
   PSET (ImR + setx, ImY + sety), clrv
END IF
RETURN

'  for fuselage surface lines in z direction
surfaceline:  
zflag = -1
xflag = 0
yflag = 0
Rz = 0
zcr = Rzhold     '   Rzhold datum from curvplot
IF zcr >= 6 THEN
   zcr = 6
END IF
IF zcr <= -6 THEN
   zcr = -6
END IF
clr = 5
GOSUB refline
RETURN

FUNCTION rho# (ntheta#, a!, b!)
   rho# = 1 / SQR((COS(ntheta#) / a!) ^ 2 + (SIN(ntheta#) / b!) ^ 2)
END FUNCTION

' -end-
